<?php
ini_set("display_errors",0);
//error_reporting(E_ALL);
function _uc_payuromania_response_page() {
  $order = uc_order_load(@$_GET['order_id']);
  if (!isset($_SESSION['cart_order']) || intval(@$_SESSION['cart_order']) != @$order->order_id) {
    drupal_set_message(t('Thank you for your order! PayU Romania will notify us once your payment has been processed.'));
    drupal_goto('cart');
  }
  $_SESSION['uc_checkout'][$_SESSION['cart_order']]['do_complete'] = TRUE;
  drupal_goto('cart/checkout/complete');
}

function _uc_payuromania_confirmation_page() {
  $payu_data = $_POST;
  if (!isset($payu_data['REFNOEXT'])) {
		drupal_set_message(t('Invalid order'),'error');
    drupal_goto('cart');
	}
  $order = uc_order_load($payu_data['REFNOEXT']);
  
  if ($order == FALSE) {
    watchdog('uc_payuromania', 'IPN attempted for non-existent order @order_id.', array('@order_id' => $order_id), WATCHDOG_ERROR);
    return;
  }
  if($order->payment_method!="payuromania")
  {
    return;
  }
  
  $vendor_name=variable_get('uc_payuromania_user', '');
  $vendor_password=variable_get('uc_payuromania_password', '');

  $pass		= $vendor_password;	/* pass to compute HASH */
  $result		= ""; 				/* string for compute HASH for received data */
  $return		= ""; 				/* string to compute HASH for return result */
  $signature	= $payu_data['HASH'];	/* HASH received */

  /* read info received */
  while(list($key, $val) = each($_POST)){
  	$$key=$val;
  	/* get values */
  	if($key != "HASH"){
  
  		if(is_array($val)) $result .= UcPayURomaniaArrayExpand($val);
  		else{
  			$size		= strlen(StripSlashes($val));
  			$result	.= $size.StripSlashes($val);
  		}
  	}
  }

  $date_return = date("YmdHis");

  $return = strlen($_POST["IPN_PID"][0]).$_POST["IPN_PID"][0].strlen($_POST["IPN_PNAME"][0]).$_POST["IPN_PNAME"][0];
  $return .= strlen($_POST["IPN_DATE"]).$_POST["IPN_DATE"].strlen($date_return).$date_return;
  $hash =  UcPayURomaniahmac($pass, $result); /* HASH for data received */
  $order_paid=0;
  //print_r($_POST);
  $ORDERSTATUS=$_POST['ORDERSTATUS'];
  if($ORDERSTATUS=='COMPLETE' || $ORDERSTATUS=='PAYMENT_AUTHORIZED' || $ORDERSTATUS=='TEST'){
      $result_hash =  UcPayURomaniahmac($pass, $return);
      $order_paid=1;
      ob_clean();
    	echo "<EPAYMENT>".$date_return."|".$result_hash."</EPAYMENT>";
  }
  else if($ORDERSTATUS=='REFUND'){
    $result_hash =  UcPayURomaniahmac($pass, $return);
    ob_clean();
  	echo "<EPAYMENT>".$date_return."|".$result_hash."</EPAYMENT>";
    exit;
  }
  if ($order_paid == 1) {
    $comment = t('PayU Romania transaction ID: @txn_id', array('@txn_id' => $payu_data['REFNO']));
    uc_payment_enter($order->order_id, 'payuromania', $order->order_total, $order->uid, NULL, $comment);
    uc_cart_complete_sale($order);
    uc_order_comment_save($order->order_id, 0, t('PayU Romania reported a payment of @amount @currency.', array('@amount' => uc_currency_format($order->order_total, FALSE), '@currency' => $payu_data['CURRENCY'])));
  }
}

function UcPayURomaniaArrayExpand($array){
	$retval = "";
	for($i = 0; $i < sizeof($array); $i++){
		$size		= strlen(StripSlashes($array[$i]));
		$retval	.= $size.StripSlashes($array[$i]);
	}

	return $retval;
}
function UcPayURomaniahmac ($key, $data) {
   $b = 64; // byte length for md5
   if (strlen($key) > $b) {
	   $key = pack("H*",md5($key));
   }
   $key  = str_pad($key, $b, chr(0x00));
   $ipad = str_pad('', $b, chr(0x36));
   $opad = str_pad('', $b, chr(0x5c));
   $k_ipad = $key ^ $ipad ;
   $k_opad = $key ^ $opad;
   return md5($k_opad  . pack("H*",md5($k_ipad . $data)));
}